import { Optional, Resource } from "../../common";
import { APIUnit, StoreUnit } from "./interfaces";
export declare class Unit extends Resource {
    /**
     * The name of the unit.
     */
    name: string;
    constructor(name: string);
    /**
     * The name of the unit resource on the API server.
     */
    static get resourceName(): string;
    /**
     * The name of the service containing the unit resource.
     */
    static get serviceName(): string;
    /**
     * Convert the unit into a JSON serializable object for the API server.
     */
    serializeAPI(): Optional<APIUnit, "id">;
    /**
     * Deserialize the data from the API server.
     *
     * @param data The unit data from the API server.
     */
    deserializeAPI(data: APIUnit): void;
    /**
     * Serialize the unit into a format for storing in the Redux store.
     */
    serializeRedux(): StoreUnit;
    /**
     * Create a unit from the API server data.
     *
     * @param data Data from the api server.
     *
     * @returns The unit object.
     */
    static apiFactory(data: APIUnit): Unit;
    /**
     * Create a unit from the Redux store data.
     *
     * @param data Data from the api server.
     *
     * @returns The unit object.
     */
    static reduxFactory(data: StoreUnit): Unit;
}
